<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
require_once('lib/obj/user.class.php');
require_once('lib/util/display.class.php');

session_start();
session_name('migcms');

$GLOBALS['smarty_config']['template_dir'] = 'inc/modules/admin/inc/templates';
$GLOBALS['smarty_config']['cache_dir'] = 'inc/modules/admin/inc/templates/cached';
$GLOBALS['smarty_config']['compile_dir'] = 'inc/modules/admin/inc/templates/compiled';


$display = new Display();


if (! isset($_SESSION['user_id'])) {
	session_register('user_id');
	session_register('user_username');
	session_register('user_email');
	session_register('user_firstname');
	session_register('user_lastname');
}

//set up a new user object
$user = new User($_SESSION['user_id']);

//populate the object via post
if (isset($_POST['username']) && isset($_POST['password'])) {
	$user->lookup_user($_POST['username'], $_POST['password'], $db);
	if (isset($_SESSION['user_id'])) { //successful login
		require_once('lib/obj/app_log.class.php');
		$log = new App_Log();
		$log->app_log_event_type = 'Admin Login';
		$log->app_log_text = 'User ' . $_SESSION['username'] . ' logged into the admin portion of the CMS';
		$log->set($db);
	}
}

if (isset($_SESSION['user_id'])) {

	$submodule = isset($_GET['submodule']) ? $_GET['submodule'] : 'default';

	if(file_exists('inc/modules/admin/inc/' . $submodule . '.php')) {
		include_once('inc/modules/admin/inc/' . $submodule . '.php');
	}
	else {
		include_once('inc/modules/admin/inc/default.php');
	}

	//display the content
	$display->show_template('default');
}
else {
	$display->show_template('login');
}

/***********************************
	Local Functions
***********************************/

/**
 * The log_event() function is provided here so that the various admin sub-modules can log events centrally.
 *
 * @param string $type
 * @param text $text
 */
function log_event($type, $text) {
		global $db;
		require_once('lib/obj/app_log.class.php');
		$log = new App_Log();
		$log->app_log_event_type = $type;
		$log->app_log_text = $text;
		$log->set($db);
}


?>