<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */

require_once('lib/obj/content.class.php');

$retval = '';

$getop = isset($_GET['getop']) ? $_GET['getop'] : 'default';

switch ($getop) {

	case 'update':
		do_update();
		break;

	case 'delete':
		do_delete();
		break;

	default:
		show_edit();
		break;
}

/*****************************************************************

				Local Functions

*****************************************************************/

function do_delete() {
	global $db;
	if ($_REQUEST['content_id']) {
		$content = new Content($_REQUEST['content_id']);
		$content->delete($db);
		header('Location:?module=admin&submodule=section&view_section=' . $_REQUEST['section_id']);
	}
}
function do_update() {
	global $db;
	if ($_REQUEST['content_id'] == '0') {
		$_REQUEST['content_id'] == '';
	}
	$update_content = new Content($_REQUEST['content_id']);
	$update_content->content_abstract = $_REQUEST['content_abstract'];
	$update_content->related_content_ids = split( ',', $_REQUEST['current_related_content_ids']);
	$update_content->content_active = $_REQUEST['content_active'];
	$update_content->content_author = $_REQUEST['content_author'];
	$update_content->content_author_email = $_REQUEST['content_author_email'];
	$update_content->content_content = $_REQUEST['content_content'];
	$update_content->content_date = date('Y-m-d H:i:s', mktime(0,0,0,$_REQUEST['content_date']['M'], $_REQUEST['content_date']['d'], $_REQUEST['content_date']['Y']));
	$update_content->content_enddate = date('Y-m-d H:i:s', mktime(0,0,0,$_REQUEST['content_enddate']['M'], $_REQUEST['content_enddate']['d'], $_REQUEST['content_enddate']['Y']));
	$update_content->content_keywords = $_REQUEST['content_keywords'];
	$update_content->content_order = $_REQUEST['content_order'];
	$update_content->content_startdate = date('Y-m-d H:i:s', mktime(0,0,0,$_REQUEST['content_startdate']['M'], $_REQUEST['content_startdate']['d'], $_REQUEST['content_startdate']['Y']));
	$update_content->content_title = $_REQUEST['content_title'];
	$update_content->section_id = $_REQUEST['section_id'];
	$update_content->content_talkback = $_REQUEST['content_talkback'];
	$update_content->user_id = $_SESSION['user_id'];
	$update_content->set($db);
	log_event('Content', 'User ' . $_SESSION['username'] . ' updated content \'' . htmlentities($update_content->content_title) . '\'');
	header('Location:?module=admin&submodule=section&view_section=' . $_REQUEST['section_id']);
}

function show_edit() {
	global $display;
	$id = isset($_GET['content_id']) ? intval($_GET['content_id']) : 0;
	$section_id = isset($_GET['section_id']) ? intval($_GET['section_id']) : 0;

	require_once 'lib/util/QuickForm.php';
	require_once 'lib/obj/collection.class.php';

		$content = new Content($id);
		$parent_sections = new Collection('section');
		if (is_array($parent_sections->members)) {
			foreach($parent_sections->members as $node) {
				$parent_ids[$node->section_id] = $node->section_title;
			}
		}

		$form = new HTML_QuickForm('edit_form', 'post', '?module=admin&submodule=content&getop=update');

		//id
		$form->addElement('hidden', 'content_id', $id);

		//title
		$form->addElement('text', 'content_title', 'Title:', 'value="' . $content->content_title . '" size="40"');

		//author and author email
		$author = $form->addElement('text', 'content_author', 'Author:', 'value="' . $content->content_author . '" size="40"');
		$author_email = $form->addElement('text', 'content_author_email', 'Author Email:', 'value="' . $content->content_author_email . '" size="40"');

		if (! $id) {
			$author->setValue($_SESSION['user_firstname'] . ' ' . $_SESSION['user_lastname']);
			$author_email->setValue($_SESSION['user_email']);
		}

		//date
		$todays_date = getdate();

		$element = $form->addElement('date', 'content_date', 'Date:'.$content->content_date, array('minYear'=>'2000'));
		if (isset($content->content_date) && $content->content_date != '') {
			$element->setValue($content->content_date);
		}
		else {
			$element->setValue($todays_date['year'].'-'.$todays_date['mon'].'-'.$todays_date['mday']);
		}

		//abstract
		$abstract = $form->addElement('textarea', 'content_abstract', 'Summary:', ' rows="10" cols="80"');
		$abstract->setValue($content->content_abstract);

		//keywords
		$form->addElement('text', 'content_keywords', 'Keywords, separated by commas:', 'value="' . $content->content_keywords . '" size="40"');

		//related content
		$related = $form->addElement('hidden', 'current_related_content_ids', '', '');
		$form->addElement('button', '', 'Manage Related Content', 'onclick="javascript:related();"');
		$related_ids ='';

		if (is_array($content->related_content_ids)) {
			foreach($content->related_content_ids as $related_content_id) {
				$related_ids .= $related_content_id . ',';
			}
			//$related_ids = substr($related_ids,0,-1);
			//$related_ids = substr($related_ids,0,count($related_ids)-1);
		}
		else {
				$related_ids ='';
		}
		$related->setValue($related_ids);

		//all possible contents to relate
		$content_for_relation = new Collection('content', 'and c.content_id != ' . $id);
		$content_relation_list = '';
		if (is_array($content_for_relation->members)) {
			foreach($content_for_relation->members as $node) {
				$content_relation_list .= $node->content_id . ',' . $node->content_title . ',';
			}
			$content_relation_list = substr($content_relation_list,0,-1);
		}
		$related = $form->addElement('hidden', 'related_content_ids', $content_relation_list, '');

		//section
		$parent_id_element = $form->addElement('select', 'section_id', 'Section:', $parent_ids);
		$parent_id_element->setSelected($section_id);

		//order
		$form->addElement('text', 'content_order', 'Order:', 'maxlength="3" value="' . $content->content_order . '" size="3"');

		//active
		$active_inactive = array(1=>'Yes', 0=>'No');
		$active_yn = $form->addElement('select', 'content_active', 'Active?:', $active_inactive);
		$active_yn->setSelected($content->content_active);

		//content body
		$content_content = $form->addElement('textarea', 'content_content', 'Body:', 'id="content_content" rows="40" cols="80"');
		$content_content->setValue($content->content_content);

		//start date
		$element = $form->addElement('date', 'content_startdate', 'Start Date:', array('minYear'=>'2006'));
		if (isset($content->content_startdate) && $content->content_startdate != '') {
			$element->setValue($content->content_startdate);
		}
		else {
			$element->setValue($todays_date['year'].'-'.$todays_date['mon'].'-'.$todays_date['mday']);
		}

		//end date
		$element = $form->addElement('date', 'content_enddate', 'End Date:', array('minYear'=>'2006'));
		if (isset($content->content_enddate) && $content->content_enddate != '') {
			$element->setValue($content->content_enddate);
		}
		else {
			$element->setValue($todays_date['year'].'-'.$todays_date['mon'].'-'.$todays_date['mday']);
		}

		//active
		$talkback_yn_arr = array(0=>'No', 1=>'Yes');
		$talkback_yn = $form->addElement('select', 'content_talkback', 'Allow User Comments?:', $talkback_yn_arr);
		$talkback_yn->setSelected($content->content_talkback);

		$form->addElement('submit', '', 'Update');

		//form rules
		$form->addRule('content_title', 'A title is required.', 'required', null, 'client');

		$display->assign('action', $_GET['getop']);
		$display->assign('form', $form->toHtml());
		$display->assign('inc_template_name', 'edit_content');
		$display->assign('title', $_GET['getop'] . ' Content');
}

?>