<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
require_once('lib/obj/collection.class.php');
require_once('lib/obj/content_image.class.php');

$retval = '';
$page_title = 'Manage Content Imagery';

$getop = isset($_GET['getop']) ? $_GET['getop'] : 'default';

switch ($getop) {

	case 'add':
		show_edit();
		break;

	case 'edit':
		show_edit();
		break;

	case 'update':
		do_update();
		break;

	case 'delete':
		do_delete();

	default:
	show_default();

}

/*****************************************************************

				Local Functions

*****************************************************************/

function do_delete() {
	global $db;
	$delete = new Content_Image($_REQUEST['id']);
	$full_filename = $GLOBALS['uploads']['upload_content_img_dir'] . $delete->content_image_filename;
	if($full_filename != '' && file_exists($full_filename)) {
		unlink($full_filename);
	}
	$delete->delete($db);
	log_event('Content Image', 'User ' . $_SESSION['username'] . ' deleted content_image \'' . htmlentities($delete->content_image_title) . '\'');
}

function do_update() {
	global $db;
	$update = new Content_Image($_REQUEST['id']);
	foreach ($_POST as $key=>$val) {
		if ($val!='') {
			$update->$key = $val;
		}
	}

	if($_FILES['image_file']['size'] != '0') {
		$filename = process_file($_FILES, $update);
		$update->content_image_filename = $filename;
	}

	$update->set($db);
	log_event('Content Image', 'User ' . $_SESSION['username'] . ' updated content_image \'' . htmlentities($update->image_title) . '\'');
	header('Location:?module=admin&submodule=content_image');
}

function process_file($file, $object) {
		require_once('lib/util/file_upload.class.php');

		//create new or overwrite old?
		if ($object->content_image_id != '') {
			//remove the old image
			$full_filename = $GLOBALS['uploads']['upload_content_img_dir'] . $object->content_image_filename;
			if(file_exists($full_filename)) {
				unlink($full_filename);
			}

		}

		//create the image thumbnail
		$imageUpload = new File_Upload($file);
		$imageUpload->formField = "image_file";
		$imageUpload->uploadType = "image";

		$imageUpload->allowExtensions = array(".jpg",".jpeg",".jpe",".gif",".png");
		$imageUpload->extensionTypes = array(".jpg",".jpg",".jpg",".gif",".png");
		$imageUpload->uploadType = "image";

		$fileType = $imageUpload->doType();
		$imageUpload->imageResize = "no";
		$imageUpload->uploadTarget = $GLOBALS['uploads']['upload_content_img_dir'];
		$imageUpload->doUpload();

		return $imageUpload->filename;

}

function show_default() {
	global $display, $page_title;
	$display_images = '';
	$images = new Collection('content_image');

	if (isset($images->members)) {
		foreach ($images->members as $image) {
			$display_images[] = array( 'content_image_title' => $image->content_image_title,
							 	 'content_image_filename' => $image->content_image_filename,
							 	 'content_image_active' => $image->content_image_active,
							 	 'content_image_id' => $image->content_image_id
							 	 );
		}
	}


	$display->assign('section_title', $page_title);
	$display->assign('title', 'Manage Content Images');
	$display->assign('image_list', $display_images);
	$display->assign('inc_template_name', 'show_content_images');

}
function show_edit() {
	global $display;
	require_once 'lib/util/QuickForm.php';

		$id = isset($_GET['id']) ? $_GET['id'] : '';
		$edit = new Content_Image($id);

		$form = new HTML_QuickForm('edit_form', 'post', '?module=admin&submodule=content_image&getop=update&id='. $id);
		$form->addElement('text', 'content_image_title', 'Title:', 'value="' . $edit->content_image_title . '"');
		$yes_no_option = array('1'=> 'Yes', '0'=>'No');
		$element = $form->addElement('select', 'content_image_active', 'Active?', $yes_no_option);
		$element->setSelected($edit->content_image_active);
		$form->addElement('file', 'image_file', 'Upload File');
		$form->addElement('submit', '', 'Update');

		$display->assign('action', $_GET['getop']);
		$display->assign('form', $form->toHtml());
		$display->assign('inc_template_name', 'edit_content_image');
		$display->assign('title', $_GET['getop'] . ' Content Image');
}
?>