<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
require_once('lib/obj/collection.class.php');
require_once('lib/obj/gallery.class.php');

$retval = '';

$getop = isset($_GET['getop']) ? $_GET['getop'] : 'default';

switch ($getop) {

	case 'add':
		show_edit();
		break;

	case 'edit':
		show_edit();
		break;

	case 'update':
		do_update();
		show_default();
		break;

	case 'delete':
		do_delete();

	default:
	show_default();

}

/*****************************************************************

				Local Functions

*****************************************************************/

function do_delete() {
	global $db;
	$delete_gallery = new Gallery($_REQUEST['id']);
	$delete_gallery->delete($db);
}

function do_update() {
	global $db;
	$update_gallery = new Gallery($_REQUEST['id']);
	$update_gallery->gallery_title = $_REQUEST['gallery_title'];
	$update_gallery->gallery_active = $_REQUEST['gallery_active'];
	$update_gallery->gallery_order = $_REQUEST['gallery_order'];
	$update_gallery->gallery_description = $_REQUEST['gallery_description'];
	$update_gallery->content_id = $_REQUEST['content_id'];
	$update_gallery->set($db);
}

function show_default() {
	global $display;
	$filter = "order by gallery_title";
	$galleries = new Collection('gallery', $filter);

	$display_contents = array();
	if (is_array($galleries->members)) {
		foreach ($galleries->members as $gallery_node) {
			$display_contents[] = array( 'gallery_title' => $gallery_node->gallery_title,
								 	 'gallery_id' => $gallery_node->gallery_id
								 	 );
		}
	}

	$display->assign('title', 'Photo Galleries');
	$display->assign('inc_template_name', 'show_galleries');
	$display->assign('contents', $display_contents);
	$display->assign('title', 'Manage Photos and Galleries');
}

function show_edit() {
	global $display;
	require_once 'lib/util/QuickForm.php';
	require_once 'lib/obj/content.class.php';

		$contents = new Collection('content', 'order by content_title');
		$display_contents = array();
		if (isset($contents->members)) {
			foreach ($contents->members as $contents_node) {
				$display_contents[$contents_node->content_id] = $contents_node->content_title;
			}
		}

		$id = isset($_GET['id']) ? $_GET['id'] : '';
		$display_gallery = new Gallery($id);

		$form = new HTML_QuickForm('edit_form', 'post', '?module=admin&submodule=gallery&getop=update&id='. $display_gallery->gallery_id);
		$form->addElement('text', 'gallery_title', 'Title:', 'value="' . $display_gallery->gallery_title . '"');
		$form->addElement('text', 'gallery_order', 'Order:', 'maxlength="3" value="' . $display_gallery->gallery_order . '" size="3"');

		$active_inactive = array(1=>'Yes', 0=>'No');
		$active_yn = $form->addElement('select', 'gallery_active', 'Active?:', $active_inactive);
		$active_yn->setSelected($display_gallery->gallery_active);

		$contet_holder = $form->addElement('select', 'content_id', 'Display on Page:', $display_contents);
		$contet_holder->setSelected($display_gallery->content_id);

		$gallery_desc = $form->addElement('textarea', 'gallery_description', 'Description:', 'id="gallery_description"');
		$gallery_desc->setValue($display_gallery->gallery_description);

		$form->addElement('submit', '', 'Update');

		$display->assign('action', $_GET['getop']);
		$display->assign('form', $form->toHtml());
		$display->assign('inc_template_name', 'edit_gallery');
		$display->assign('title', $_GET['getop'] . ' Gallery');
}
?>