<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */

require_once('lib/obj/photo.class.php');

$retval = '';

$getop = isset($_GET['getop']) ? $_GET['getop'] : 'default';

switch ($getop) {

	case 'update':
		do_update();
		break;

	case 'delete':
		do_delete();
		break;

	case 'edit':
		show_edit();
		break;

	case 'add':
		show_edit();
		break;

	default:
		show_default();
		break;
}

/*****************************************************************

				Local Functions

*****************************************************************/

function do_delete() {
	global $db;
	$photo_id = isset($_REQUEST['photo_id']) ? $_REQUEST['photo_id'] : '';
	$delete_photo = new Photo($photo_id);
	$full_file = $GLOBALS['uploads']['upload_thumb_dir'] . $delete_photo->photo_filename;
	if (file_exists($full_file)) {
		unlink($full_file);
	}
	$delete_photo->delete($db);

}

function do_update() {
	global $db;
	if ($_REQUEST['photo_id'] == '0') {
		$_REQUEST['photo_id'] == '';
	}
	$gallery_id = isset($_GET['gallery']) ? $_GET['gallery'] : 0;
	$photo_id = isset($_REQUEST['photo_id']) ? $_REQUEST['photo_id'] : '';

	$update_photo = new Photo($photo_id);

	if($_FILES['upload_file']['size'] != '0') {
		$filename = process_file($_FILES, $update_photo);
	}

	$update_photo->photo_title = $_REQUEST['photo_title'];
	$update_photo->photo_active = $_REQUEST['photo_active'];
	$update_photo->gallery_id = $gallery_id;
	$update_photo->photo_order = $_REQUEST['photo_order'];
	$update_photo->photo_description = $_REQUEST['photo_description'];
	if (isset($filename)) {
		$update_photo->photo_filename = $filename;
	}

	$update_photo->set($db);
	header('Location:?module=admin&submodule=photo&gallery=' . $gallery_id);
}

function process_file($file, $photo_object) {
		require_once('lib/util/file_upload.class.php');

		//create new or overwrite old?
		if ($photo_object->photo_id != '') {
			//remove the old image
			$full_filename = $GLOBALS['uploads']['upload_thumb_dir'] . $photo_object->photo_filename;
			if(file_exists($full_filename)) {
				unlink($full_filename);
			}

		}

		//create the image thumbnail
		$imageUpload = new File_Upload($file);
		$imageUpload->formField = "upload_file";
		$imageUpload->allowExtensions = array(".jpg",".jpeg",".jpe",".gif");
		$imageUpload->extensionTypes = array(".jpg",".jpg",".jpg",".gif");
		$imageUpload->uploadType = "image";
		$imageUpload->height = $GLOBALS['uploads']['photo_resize_height'];
		$imageUpload->width = $GLOBALS['uploads']['photo_resize_width'];
		$imageUpload->imageResize = $GLOBALS['uploads']['resize_photos'];
		$fileType = $imageUpload->doType();
		if ($fileType != "unknown") {
			$imageUpload->fileExtension = $fileType;
			$imageUpload->doUpload();
			$imageUpload->makeThumb();
			//remove the original (for now)
			if (file_exists($imageUpload->upload_filename)) {
					unlink($imageUpload->upload_filename);
			}
		}
		else {
			//unknown file type
			$pageErrors = "Unknown or unsupported file type.  Only JPEG, and GIF are currently supported.";
		}
		return $imageUpload->filename;

}

function show_default() {
	global $display;
	require_once 'lib/obj/collection.class.php';

	$gallery_id = isset($_GET['gallery']) ? intval($_GET['gallery']) : 0;
	require_once 'lib/obj/gallery.class.php';
	$gallery = new Gallery($gallery_id);

	$photos = new Collection('photo', 'where gallery_id = ' . $gallery_id);

	$display_contents = array();
	if (is_array($photos->members)) {
		foreach ($photos->members as $photos_node) {
			$display_contents[] = array( 'photo_title' => $photos_node->photo_title,
								 	 'photo_id' => $photos_node->photo_id
								 	 );
		}
	}

	$display->assign('title', 'Photos');
	$display->assign('inc_template_name', 'show_photos');
	$display->assign('contents', $display_contents);
	$display->assign('gallery_id', $gallery_id);
	$display->assign('gallery_title', $gallery->gallery_title);
	$display->assign('title', 'Gallery Photos');
}

function show_edit() {
	global $display;
	$gallery_id = isset($_GET['gallery']) ? intval($_GET['gallery']) : 0;
	$photo_id = isset($_GET['photo_id']) ? intval($_GET['photo_id']) : 0;

	require_once 'lib/util/QuickForm.php';
	require_once 'lib/obj/collection.class.php';

		$photo = new Photo($photo_id);
		$galleries = new Collection('gallery');

		foreach($galleries->members as $node) {
			$gallery_ids[$node->gallery_id] = $node->gallery_title;
		}

		$form = new HTML_QuickForm('edit_form', 'post', '?module=admin&submodule=photo&getop=update&gallery=' . $gallery_id, '', 'enctype="multipart/form-data"');
		$form->addElement('text', 'photo_title', 'Title:', 'value="' . $photo->photo_title . '"');
		$abstract = $form->addElement('textarea', 'photo_description', 'Descrption:');
		$abstract->setValue($photo->photo_description);

		if (isset($photo->photo_filename)) {
			$display->assign('preview', 'img/gallery/thumbnails/' . $photo->photo_filename);
			$form->addElement('file', 'upload_file', 'Replace Image:');
		}
		else {
			$form->addElement('file', 'upload_file', 'File:');
		}

		$parent_id_element = $form->addElement('select', 'gallery_id', 'Gallery:', $gallery_ids);
		$parent_id_element->setSelected($gallery_id);

		$form->addElement('text', 'photo_order', 'Order:', 'maxlength="3" value="' . $photo->photo_order . '" size="3"');

		$active_inactive = array(1=>'Yes', 0=>'No');
		$active_yn = $form->addElement('select', 'photo_active', 'Active?:', $active_inactive);
		$active_yn->setSelected($photo->photo_active);

		$form->addElement('hidden', 'photo_id', $photo_id);
		$form->addElement('submit', '', 'Update');

		//form rules
		$form->addRule('photo_title', 'A title is required.', 'required', null, 'client');
		if (! isset($photo->photo_filename)) {
			$form->addRule('upload_file', 'A file is required.', 'required', null, 'client');
		}

		$display->assign('action', $_GET['getop']);
		$display->assign('form', $form->toHtml());
		$display->assign('inc_template_name', 'edit_photo');
		$display->assign('title', $_GET['getop'] . ' Photo');
}

?>