<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
	require_once('lib/util/report.class.php');
	require_once('lib/obj/app_log.class.php');
	require_once('lib/obj/usage_log.class.php');
	require_once('lib/obj/collection.class.php');

	$usage_log_filter = ' where usage_log_id_date > date_sub(now(), interval 1 day)';
	$usage_logs = new Collection('usage_log', $usage_log_filter);



	$ulogs = '';
	if (isset($usage_logs->members)) {
		foreach ($usage_logs->members as $ulog_entry) {
			$ulogs[] = array('usage_log_remote_addr' => $ulog_entry->usage_log_remote_addr . '[' . gethostbyaddr($ulog_entry->usage_log_remote_addr) . ']',
								'usage_log_referer' => $ulog_entry->usage_log_referer,
								'usage_log_user_agent' => $ulog_entry->usage_log_user_agent,
								'usage_log_page' => $ulog_entry->usage_log_page,
								'usage_log_content_id' => $ulog_entry->usage_log_content_id,
								'usage_log_section_id' => $ulog_entry->usage_log_section_id,
								'content_title' => $ulog_entry->content_title,
								'section_title' => $ulog_entry->section_title,
								'usage_log_id_date' => $ulog_entry->usage_log_id_date
								);
		}
	}
	$hit_count = count($ulogs);

	$log = new App_Log();
	$report = new Report($db);

	$log_entries = $log->report_log(' order by app_log_datetime desc limit 20');
	$app_log = '';
	if (is_array($log_entries)) {
		foreach($log_entries as $entry) {
			$app_log[] = $entry;
		}
	}

	$display->assign('app_log', $app_log);

	$display->assign('hit_count', $hit_count);
	$display->assign('ulogs', $ulogs);

	$display->assign('search_terms_1', $report->search_term_report_1());
	$display->assign('content_1', $report->content_report_1());
	$display->assign('content_2', $report->content_report_2());

	$display->assign('title', 'Reports');
	$display->assign('inc_template_name', 'reports');
?>