<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
require_once('lib/obj/collection.class.php');
require_once('lib/obj/section.class.php');

$retval = '';

$getop = isset($_GET['getop']) ? $_GET['getop'] : 'default';

switch ($getop) {

	case 'add':
		show_edit();
		break;

	case 'edit':
		show_edit();
		break;

	case 'update':
		do_update();
		show_default();
		break;

	case 'delete':
		do_delete();

	default:
	show_default();

}

/*****************************************************************

				Local Functions

*****************************************************************/

function breadcrumb($id) {
	$bc_section = new Section($id);
	$uplist[0] = array('section_id' => $bc_section->section_id, 'section_title' => $bc_section->section_title);

	while ($bc_section->section_parent_id !== '0') {
		$bc_section = new Section($bc_section->section_parent_id);
		$uplist[] = array('section_id' => $bc_section->section_id, 'section_title' => $bc_section->section_title);
	}


	$uplist[] = array('section_id' => '0', 'section_title' => 'Top');
	//flip the values
	$y=0;
	for ($x=count($uplist);$x>0;$x--) {
		$retval[$y] = $uplist[$x-1];
		$y++;
	}
	return $retval;
}

function do_delete() {
	global $db;
	$delete_section = new Section($_REQUEST['id']);
	$delete_section->delete($db);
}

function do_update() {
	global $db;
	$update_section = new Section($_REQUEST['id']);
	$update_section->section_title = $_REQUEST['section_title'];
	$update_section->section_parent_id = $_REQUEST['section_parent_id'];
	$update_section->section_order = $_REQUEST['section_order'];
	$update_section->section_active = $_REQUEST['section_active'];
	$update_section->set($db);
}

function show_default() {
	global $display;
	$viewsection = isset($_GET['view_section']) ? intval($_GET['view_section']) : 0;

	if ($viewsection != 0) {
		$crumb_trail = breadcrumb($viewsection);
		$display->assign('breadcrumbs', $crumb_trail);
	}

	$filter = "where section_parent_id = '" . $viewsection . "' order by section_title";
	$sections = new Collection('section', $filter);

	$display_sections = array();
	if (isset($sections->members)) {
		foreach ($sections->members as $section_node) {
			$display_sections[] = array( 'section_title' => $section_node->section_title,
							 	 'section_id' => $section_node->section_id
							 	 );
		}
	}

	$filter = "AND c.section_id = '" . $viewsection . "' order by c.content_title";
	$contents = new Collection('content', $filter);
	$display_contents = array();
	if (isset($contents->members)) {
		foreach ($contents->members as $contents_node) {
			$display_contents[] = array( 'content_title' => $contents_node->content_title,
							 	 'content_id' => $contents_node->content_id,
							 	 'section_id' => $contents_node->section_id
							 	 );
		}
	}

	$page_title = isset($crumb_trail) ? $crumb_trail[count($crumb_trail)-1]['section_title'] : 'Top Level';

	$display->assign('section_title', $page_title);

	$display->assign('view_section', $viewsection);
	$display->assign('inc_template_name', 'show_sections');
	$display->assign('sections', $display_sections);
	$display->assign('contents', $display_contents);
	$display->assign('title', 'Manage Content');
}
function show_edit() {
	global $display;
	require_once 'lib/util/QuickForm.php';

		$id = isset($_GET['id']) ? $_GET['id'] : '';
		$display_section = new Section($id);
		$parent_section_id = isset($display_section->section_parent_id) ? $display_section->section_parent_id : $_GET['parent_section_id'];

		$parent_sections = new Collection('section');
		$parent_ids[0] = 'Top Level';

		if(is_array($parent_sections->members)) {
			foreach($parent_sections->members as $node) {
				$parent_ids[$node->section_id] = $node->section_title;
			}
		}

		if (isset($_GET['parent_section_id'])) {
			$display_section->section_parent_id = $_GET['parent_section_id'];
		}

		$form = new HTML_QuickForm('edit_form', 'post', '?module=admin&submodule=section&getop=update&view_section=' . $display_section->section_parent_id . '&id='. $display_section->section_id);
		$form->addElement('text', 'section_title', 'Title:', 'value="' . $display_section->section_title . '"');
		$parent_id_element = $form->addElement('select', 'section_parent_id', 'Parent:', $parent_ids);
		$parent_id_element->setSelected($parent_section_id);
		$form->addElement('text', 'section_order', 'Order:', 'maxlength="3" value="' . $display_section->section_order . '" size="3"');

		$active_inactive = array(1=>'Yes', 0=>'No');
		$active_yn = $form->addElement('select', 'section_active', 'Active?:', $active_inactive);
		$active_yn->setSelected($display_section->section_active);

		$form->addElement('submit', '', 'Update');

		$display->assign('action', $_GET['getop']);
		$display->assign('form', $form->toHtml());
		$display->assign('inc_template_name', 'edit_section');
		$display->assign('title', $_GET['getop'] . ' Section');
}
?>