<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
require_once('lib/obj/collection.class.php');
require_once('lib/obj/section.class.php');

$retval = '';
$page_title = 'Admin Users';

$id = isset($_GET['id']) ? $_GET['id'] : '';
$getop = isset($_GET['getop']) ? $_GET['getop'] : 'default';

switch ($getop) {

	case 'add':
		if ($_SESSION['user_id'] === '1') {
			show_edit();
			break;
		}

	case 'edit':
		if (check_editable($id)) {
			show_edit();
			break;
		}

	case 'update':
		if (check_editable($id)) {
			do_update();
			show_default();
			break;
		}

	case 'delete':
		if ($_SESSION['user_id'] === 1) {
			do_delete();
		}

	default:
	show_default();

}

/*****************************************************************

				Local Functions

*****************************************************************/

/**
 * This function is used to check to make sure the account specified can be edited (i.e. either the account is the same one as the user is logged in under or the user is admin (user_id = 1).
 *
 * @param int $id
 */
function check_editable($id) {
	if ( ($_SESSION['user_id'] === '1') || ($id === $_SESSION['user_id']) ) {
		return true;
	}
	else {
		return false;
	}
}

function do_delete() {
	global $db;
	$delete = new User($_REQUEST['id']);
	$delete->delete($db);
}

function do_update() {
	global $db;
	$update_user = new User($_REQUEST['id']);
	foreach ($_POST as $key=>$val) {
		if (substr($key, 0, 5) == 'user_') {
			$update_user->$key = $val;
		}
	}
	$update_user->set($db);
}

function show_default() {
	global $display, $page_title;

	$users = new Collection('user');

	if (isset($users->members)) {
		foreach ($users->members as $user) {
			$display_users[] = array( 'user_firstname' => $user->user_firstname,
							 	 'user_lastname' => $user->user_lastname,
							 	 'user_username' => $user->user_username,
							 	 'user_email' => $user->user_email,
							 	 'user_id' => $user->user_id
							 	 );
		}
	}


	$display->assign('section_title', $page_title);
	$display->assign('title', 'Manage Users');
	$display->assign('user_list', $display_users);
	$display->assign('inc_template_name', 'show_users');
	$display->assign('user_account', $_SESSION['user_id']);

}
function show_edit() {
	global $display;
	require_once 'lib/util/QuickForm.php';

		$id = isset($_GET['id']) ? $_GET['id'] : '';
		$edit_user = new User($id);

		$form = new HTML_QuickForm('edit_form', 'post', '?module=admin&submodule=users&getop=update&id='. $id);
		$form->addElement('text', 'user_firstname', 'First Name:', 'value="' . $edit_user->user_firstname . '"');
		$form->addElement('text', 'user_lastname', 'Last Name:', 'value="' . $edit_user->user_lastname . '"');
		$form->addElement('text', 'user_email', 'Email:', 'value="' . $edit_user->user_email . '"');
		$form->addElement('text', 'user_username', 'User Name:', 'value="' . $edit_user->user_username . '"');
		$form->addElement('text', 'user_password', 'Password:', 'value="' . $edit_user->user_password . '"');
		$form->addElement('submit', '', 'Update');

		$display->assign('action', $_GET['getop']);
		$display->assign('form', $form->toHtml());
		$display->assign('inc_template_name', 'edit_user');
		$display->assign('title', $_GET['getop'] . ' User');
}
?>