<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
require_once('lib/obj/collection.class.php');
require_once('lib/obj/section.class.php');
require_once('lib/obj/content.class.php');
require_once('lib/obj/talkback.class.php');

if (isset($_GET['talkback'])) {
	post_talkback($_POST);  //local function below
}

//set up the content itself
$content = new Content($content_id); //$content_id set up in ../default.php

$talkbacks = new Collection('talkback', 'where content_id = \'' . $content_id . '\'');
$talkback_arr = '';
if (is_array($talkbacks->members)) {
	foreach($talkbacks->members as $tb_item) {
		$talkback_arr[] = array('talkback_title' => $tb_item->talkback_title,
								'talkback_author' => $tb_item->talkback_author,
								'talkback_email' => $tb_item->talkback_email,
								'talkback_datetime' => $tb_item->talkback_datetime,
								'talkback_content' => str_replace("\n", '<br/>',$tb_item->talkback_content)
								);
	}
}

//make sure the section_id is set properly
if ($section_id == 0) {
	$section_id = $content->section_id;
}


$section_contents = new Collection('content', 'AND c.section_id = ' . $section_id);
$contents = '';
if (is_array($section_contents->members)) {
	foreach($section_contents->members as $item) {
		$contents[] = array('content_id' => $item->content_id,
								'content_title' => $item->content_title,
								'content_abstract' => $item->content_abstract);
	}
}




$sub_level_sections = new Collection('section', 'where section_active = 1 AND section_parent_id = ' . $section_id);
//set up the sub nav array
$sub_section_display = '';
if (is_array($sub_level_sections->members)) {
	foreach($sub_level_sections->members as $section) {
		$sub_section_display[] = array('section_id' => $section->section_id,
									'section_title' => $section->section_title);
	}
}
//set up breadcrumb trail using function breadcrumb() in ../default.php
$crumb_trail = '';
if ($section_id != 0) {
	$crumb_trail = breadcrumb($section_id);
}

//check to see if there is a photo gallery
require_once('lib/obj/gallery.class.php');
$galleries = new Collection('gallery', 'where content_id = ' . $content_id );
$gallery_display = '';
if (is_array($galleries->members)) {
	foreach($galleries->members as $gallery) {
		$gallery_display[] = array('gallery_id' => $gallery->gallery_id,
									'gallery_title' => $gallery->gallery_title);
	}
}


$display->assign('section_content', $contents);
$display->assign('title', $GLOBALS['site']['title'] . ' :: ' . htmlentities($content->content_title));
$display->assign('section2', $sub_section_display);
$display->assign('breadcrumbs', $crumb_trail);

$display->assign('meta_description', htmlentities($content->content_abstract));
$display->assign('meta_author', htmlentities($content->content_author));
$display->assign('meta_keywords', htmlentities($content->content_keywords));

$display->assign('content_author', $content->content_author);
$display->assign('content_author_email', $content->content_author_email);
$display->assign('content_content', $content->content_content);
$display->assign('content_date', $content->content_date);
$display->assign('content_title', $content->content_title);
$display->assign('related', $content->content_related_display_array);

$display->assign('display_talkback',  $content->content_talkback);
$display->assign('talkback', $talkback_arr);

$display->assign('url', '?content_id=' . $content->content_id);

$display->assign('galleries', $gallery_display);

$display->assign('inc_template_name', 'content');


/*****************************************************************

				Local Functions

*****************************************************************/

function post_talkback($post_arr) {
	global $db;
	require_once('lib/obj/talkback.class.php');
	$comment = new Talkback();
	$comment->talkback_title = htmlentities($post_arr['title']);
	$comment->talkback_author = htmlentities($post_arr['name']);
	$comment->talkback_email = htmlentities($post_arr['email']);
	$comment->talkback_content = htmlentities($post_arr['comment']);
	$comment->content_id = $_GET['content_id'];
	$comment->talkback_ip = $_SERVER['REMOTE_ADDR'];
	$comment->set($db);
	header('Location:?content_id=' . $_REQUEST['content_id']);
}

?>