<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract  This is the master controller for the entire application.  All page requests are handled by index.php and then passed of to the appropriate sub-controllers in inc/ depending on the page call.  This page is also responsible for handling the building and tearing down of the data layer connection ($db) that is passed on to sub controllers.  The page also implements Paser_Config(), the class that loads the configuration settings from /conf/config.ini.
 *
 * @todo
 */

$GLOBALS['application']['app_root'] = strrev(stristr(strrev($_SERVER['SCRIPT_FILENAME']),'/'));

require_once('lib/util/parse_config.class.php');
require_once('lib/util/db_object.class.php');

if ($load_config = new Parse_Config()) {
	$db = new DB_Object();
}

if (isset($_GET['module'])) {
	$module = $_GET['module'];
}
else {
	$module = 'content';
}

if(file_exists('inc/modules/' . $module .'/default.php')) {
		include('inc/modules/' . $module .'/default.php');
}
else {
		include('inc/modules/content/default.php');
}

$db->close();

?>