<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract
 *
 * @todo
 */
if (! isset($GLOBALS['application']['app_root'])) {
	$app_path = explode('/', $_SERVER['PHP_SELF']);
	$inc_path = $_SERVER['DOCUMENT_ROOT'] . '/' . $app_path[1] . '/';
}
else {
	$inc_path = $GLOBALS['application']['app_root'];
}
require_once($inc_path . 'lib/obj/abstract_object.class.php');

Class Content extends Abstract_Object {

		var $content_id;
		var $content_abstract;
		var $content_active;
		var $content_author;
		var $content_author_email;
		var $content_content;
		var $content_date;
		var $content_enddate;
		var $content_keywords;
		var $content_order;
		var $content_post_date;
		var $content_sectiondefault;
		var $content_startdate;
		var $content_title;
		var $contenttype_id;
		var $section_id;
		var $section_title;
		var $user_id;
		var $content_talkback;

		/**
		 * $related_content_ids is an array of content_id's that are mapped in the related table to the object's content_id
		 *
		 * @var array
		 */
		var $related_content_ids;
		/**
		 * This is an associative array in the format array ( [content_id] => value, [content_title] => value, [content_abstract] => value).
		 * This array is generated by way of the related_content_ids
		 *
		 * @var array
		 */
		var $content_related_display_array;

	function __construct($id='') {
		parent::__construct();
		$sql = 'select c.*,
					s.section_title
				from content c,
					section s
				where
					c.section_id = s.section_id
					AND c.content_id = \'' . $id . '\'';
		$attributes = $this->db->get_all($sql);
		if (is_array($attributes) && count($attributes) > 0) {
			foreach ($attributes[0] as $key=>$val) {
				$this->$key = $val;
			}
		}
		$sql = 'select related_content_id
				from related
				where
					content_id = \'' . $id . '\'';
		$attributes = $this->db->get_all($sql);
		$related_contents = '';
		if (is_array($attributes) && count($attributes) > 0) {
			foreach ($attributes as $item) {
				$related_contents[] = $item['related_content_id'];
			}
		}
		$this->related_content_ids = $related_contents;
		//populate up related items for display
		if (is_array($this->related_content_ids)) {
			$these_ids = implode(',', $this->related_content_ids);
			$sql = 'select content_id, content_title, content_abstract
						from content where content_id IN (' . $these_ids . ')';
			$attributes = $this->db->get_all($sql);
			if (is_array($attributes) && count($attributes) > 0) {
				foreach ($attributes as $item) {
					$this->content_related_display_array[] =  array('content_id' => $item['content_id'],
																	'content_title' => $item['content_title'],
																	'content_abstract' => $item['content_abstract']);
				}
			}
		}
	}

	function get_definition($filter='') {
		return "select c.*, s.section_title
				from content c,
					section s
				where c.section_id = s.section_id " . $filter;
	}

	function delete($db) {

			$statement = 'delete from content where content_id = ?';
			$types = array('integer');
			$data = array($this->content_id);

			$db->prep_statement($statement, $types,$data);
	}

	function set($db) {

		if (! isset($this->content_id)) {
			//insert a new record
			$statement = 'insert into content (
								content_abstract,
								content_active,
								content_author,
								content_author_email,
								content_content,
								content_date,
								content_enddate,
								content_keywords,
								content_order,
								content_post_date,
								content_sectiondefault,
								content_startdate,
								content_title,
								contenttype_id,
								section_id,
								content_talkback,
								user_id  )
							values (
								?,
								?,
								?,
								?,
								?,
								?,
								?,
								?,
								?,
								?,
								?,
								?,
								?,
								1,
								?,
								?,
								?
							)';
			$types = array('text',
							'integer',
							'text',
							'text',
							'text',
							'timestamp',
							'timestamp',
							'text',
							'integer',
							'timestamp',
							'integer',
							'timestamp',
							'text',
							'integer',
							'boolean',
							'integer');

			$data = array(
								$this->content_abstract,
								$this->content_active,
								$this->content_author,
								$this->content_author_email,
								$this->content_content,
								$this->content_date,
								$this->content_enddate,
								$this->content_keywords,
								$this->content_order,
								$this->content_post_date,
								$this->content_sectiondefault,
								$this->content_startdate,
								$this->content_title,
								$this->section_id,
								$this->contact_talkback,
								$_SESSION['user_id']
							);

		}
		else {
			$statement = 'update content
								set content_abstract =?,
								content_active =?,
								content_author =?,
								content_author_email =?,
								content_content =?,
								content_date =?,
								content_enddate =?,
								content_keywords =?,
								content_order =?,
								content_post_date =?,
								content_sectiondefault =?,
								content_startdate =?,
								content_title =?,
								contenttype_id =?,
								section_id =?,
								user_id = ?,
								content_talkback = ?
						where content_id = ?';
			$types = array(
							'text', 'boolean', 'text', 'text', 'text', 'date', 'date', 'text', 'integer', 'date', 'boolean', 'date', 'text', 'integer', 'integer', 'integer', 'boolean', 'integer');
			$data = array(
							$this->content_abstract,
							$this->content_active,
							$this->content_author,
							$this->content_author_email,
							$this->content_content,
							$this->content_date,
							$this->content_enddate,
							$this->content_keywords,
							$this->content_order,
							$this->content_post_date,
							$this->content_sectiondefault,
							$this->content_startdate,
							$this->content_title,
							$this->contenttype_id,
							$this->section_id,
							$_SESSION['user_id'],
							$this->content_talkback,
							$this->content_id
							);
		}
		$db->prep_statement($statement, $types,$data);
		//do the related contents
		$sql = 'delete from related where content_id = ?';
		$values = array($this->content_id);
		$types = array('integer');
		$db->prep_statement($sql, $types, $values);

		$sql = 'insert into related (content_id, related_content_id, related_order) values (' . $this->content_id . ',?,0)';
		foreach ($this->related_content_ids as $element_id) {
			if ($element_id != '') {
				$values = array($element_id);
				$db->prep_statement($sql, $types, $values);
			}
		}

	}
}

?>