<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 * 
 * @abstract Galelry object.
 * 
 * @todo 
 */

require_once('lib/obj/abstract_object.class.php');

Class Gallery extends Abstract_Object {
	
	var $gallery_id;
	var $gallery_active;
	var $gallery_description;
	var $gallery_order;
	var $gallery_title;
	var $content_id;
	
	var $name = 'gallery';
	
	//this could probably also be abstracted, but perhaps not.
	function __construct($id='') {
		parent::__construct();
		$sql = 'select * from gallery where gallery_id = \'' . $id . '\'';
		$attributes = $this->db->get_all($sql);
		if (is_array($attributes) && count($attributes) > 0) {
			foreach ($attributes[0] as $key=>$val) {
				$this->$key = $val;
			}
		}
	}
	
	function get_definition($filter='') {
		return "select * from gallery " . $filter;
	}
	
	function delete($db) {
			
			$data = array($this->gallery_id);
			$types = array('integer');
			
			$sql = 'select photo_filename from photo where gallery_id = \'' . $this->gallery_id . '\'';
			$photo_locations = $this->db->get_all($sql);
			foreach ($photo_locations as $file) {
					$full_file = $GLOBALS['uploads']['upload_thumb_dir'] . $file['photo_filename'];
					if (file_exists($full_file)) {
						unlink($full_file);
					}
				
			}
			
			$statement = 'delete from photo where gallery_id = ?';
			$db->prep_statement($statement, $types,$data);
			
			$statement = 'delete from gallery where gallery_id = ?';
			$db->prep_statement($statement, $types,$data);
	}
	
	function set($db) {
		if (! isset($this->gallery_id)) {
			//insert a new record
			$statement = 'insert into gallery (
								gallery_active,
								gallery_description,
								gallery_order,
								gallery_title,
								content_id
								 )
							values (
								?,
								?,
								?,
								?,
								?							
							)';
			$types = array( 'integer','text',  'integer', 'text', 'integer');
			$data = array($this->gallery_active, 
							$this->gallery_description, 
							$this->gallery_order,
							$this->gallery_title,
							$this->content_id );
			
		}
		else {
			$statement = 'update gallery 
								set gallery_active= ?,
									gallery_description= ?,
									gallery_order = ?,
									gallery_title = ?,
									content_id = ?
						where gallery_id = ?';
			$types = array('integer', 'text', 'integer', 'text', 'integer', 'integer');
			$data = array($this->gallery_active, 
							$this->gallery_description,
							$this->gallery_order, 
							$this->gallery_title,
							$this->content_id,
							$this->gallery_id );
		}
		$db->prep_statement($statement, $types,$data);
	}
	
}

?>