<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 0.1
 *
 * @abstract Section for the admin side.
 *
 * @todo
 */

require_once('lib/obj/abstract_object.class.php');

Class Section extends Abstract_Object {

	var $section_id;
	var $section_title;
	var $section_active;
	var $section_order;
	var $section_parent_id;

	var $name = 'section';

	//this could probably also be abstracted, but perhaps not.
	function __construct($id='') {
		parent::__construct();
		$sql = 'select * from section where section_id = \'' . $id . '\'';
		$attributes = $this->db->get_all($sql);
		if (is_array($attributes) && count($attributes) > 0) {
			foreach ($attributes[0] as $key=>$val) {
				$this->$key = $val;
			}
		}
	}

	function get_definition($filter='') {
		return "select * from section " . $filter;
	}

	function delete($db) {

			$sql = 'select content_id from content where section_id = \'' . $this->section_id . '\'';
			$content_ids = $this->db->get_all($sql);
			$statement = 'delete from related where content_id = ? OR related_content_id = ?';
			$types = array('integer', 'integer');
			foreach ($content_ids as $content_id) {
				$data = array($content_id['content_id'], $content_id['content_id']);
				$db->prep_statement($statement, $types,$data);
			}

			$statement = 'delete from content where section_id = ?';
			$types = array('integer');
			$data = array($this->section_id);

			$db->prep_statement($statement, $types,$data);

			$statement = 'delete from section where section_id = ?';
			$types = array('integer');
			$data = array($this->section_id );

			$db->prep_statement($statement, $types,$data);
	}

	function set($db) {
		if (! isset($this->section_id)) {
			//insert a new record
			$statement = 'insert into section (
								section_title,
								section_parent_id,
								section_order,
								section_active )
							values (
								?,
								?,
								?,
								?
							)';
			$types = array('text', 'integer', 'integer', 'integer');
			$data = array($this->section_title,
							$this->section_parent_id,
							$this->section_order,
							$this->section_active);

		}
		else {
			$statement = 'update section
								set section_title= ?,
									section_parent_id= ?,
									section_order = ?,
									section_active = ?
						where section_id = ?';
			$types = array('text', 'integer', 'integer', 'integer', 'integer');
			$data = array($this->section_title,
							$this->section_parent_id,
							$this->section_order,
							$this->section_active,
							$this->section_id );
		}
		$db->prep_statement($statement, $types,$data);
	}

}

?>