<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract This object is used to collect application specific information.
 *
 * @todo
 */

require_once('lib/obj/abstract_object.class.php');

Class Talkback extends Abstract_Object {

	var $talkback_id;
	var $content_id;
	var $talkback_title;
	var $talkback_email;
	var $talkback_author;
	var $talkback_datetime;
	var $talkback_content;
	var $talkback_ip;


	function __construct($id='') {
		parent::__construct();
		$sql = 'select *
				from talkback
				where talkback_id = \'' . $id . '\'';
		$attributes = $this->db->get_all($sql);
		if (is_array($attributes) && count($attributes) > 0) {
			foreach ($attributes[0] as $key=>$val) {
				$this->$key = $val;
			}
		}
	}

	function get_definition($filter='') {
		return "select * from talkback " . $filter;
	}

	function delete($db) {
			$statement = 'delete from talkback where talkback_id = ?';
			$types = array('integer');
			$data = array($this->content_id);

			$db->prep_statement($statement, $types,$data);
	}

	function set($db) {

		if (! isset($this->talkback_id)) {
			//insert a new record
			$statement = 'insert into talkback (
								content_id,
								talkback_title,
								talkback_email,
								talkback_author,
								talkback_datetime,
								talkback_content,
								talkback_ip
								  )
							values (
								?,
								?,
								?,
								?,
								now(),
								?,
								?
							)';
			$types = array('integer',
							'text',
							'text',
							'text',
							'text',
							'text');

			$data = array(
								$this->content_id,
								$this->talkback_title,
								$this->talkback_email,
								$this->talkback_author,
								$this->talkback_content,
								$this->talkback_ip
							);

		}
		else {
			$statement = 'update content
								set content_id =?,
								talkback_title =?,
								talkback_email =?,
								talkback_author =?,
								talkback_datetime = now(),
								talkback_content =?,
								talkback_ip =?
						where talkback_id = ?';
			$types = array(
							'integer', 'text', 'text', 'text', 'text', 'text', 'integer'
							);
			$data = array(
							$this->content_id,
							$this->talkback_title,
							$this->talkback_email,
							$this->talkback_author,
							$this->talkback_content,
							$this->talkback_ip,
							$this->talkback_id
							);
		}
		$db->prep_statement($statement, $types,$data);

	}
}

?>