<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract This object is used to collect application specific information.
 *
 * @todo
 */

require_once('lib/obj/abstract_object.class.php');

Class Usage_Log extends Abstract_Object {

	var $usage_log_remote_addr;
	var $usage_log_referer;
	var $usage_log_user_agent;
	var $usage_log_page;
	var $usage_log_content_id;
	var $usage_log_section_id;

	function __construct($id='') {
		parent::__construct();
		//$sql = 'select * from usage_log where usage_log_id = \'' . $id . '\'';
		$sql = 'select u.*,
				c.content_title,
				s.section_title
				from usage_log u
				left outer join content c
				on c.content_id = u.usage_log_content_id
				left outer join section s
				on s.section_id = u.usage_log_section_id
				where u.usage_log_id = \'' . $id . '\'';
		$attributes = $this->db->get_all($sql);
		if (is_array($attributes) && count($attributes) > 0) {
			foreach ($attributes[0] as $key=>$val) {
				$this->$key = $val;
			}
		}
	}

	function get_definition($filter='') {
		return "select * from usage_log " . $filter;
	}

	function set($db) {

			$statement = 'insert into usage_log (
								usage_log_remote_addr,
								usage_log_referer,
								usage_log_user_agent,
								usage_log_page,
								usage_log_content_id,
								usage_log_section_id )
							values (
								?,
								?,
								?,
								?,
								?,
								?
							)';
			$types = array( 'text',
							'text',
							'text',
							'text',
							'integer',
							'integer'
						);

			$data = array(
								$this->usage_log_remote_addr,
								$this->usage_log_referer,
								$this->usage_log_user_agent,
								$this->usage_log_page,
								$this->usage_log_content_id,
								$this->usage_log_section_id
							);

		$db->prep_statement($statement, $types,$data);
	}

}
?>