<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract This is a wrapper class for Smarty.
 *
 * @todo
 */

require_once('lib/util/Smarty/Smarty.class.php');

Class Display extends Smarty {

	/**
	 * Extends Smarty and loads all the necessary Smarty configuration.
	 *
	 */
	function __construct() {
		new Smarty();
		$this->load_config();
	}

	/**
	 * Wrapper function for Smarty::display, appends '.tpl' to the input parameter and displays that page.
	 *
	 * @param string $page
	 */
	function show_template($page) {
		$this->display($page.'.tpl');
	}

	/**
	 * This function loads all the $GLOBAL['smarty_config'] variables into local object properties for Smarty.
	 *
	 * @param string $config
	 */
	function load_config() {
		foreach ($GLOBALS['smarty_config'] as $key=>$val) {
			$this->$key = $val;
		}
	}
}



?>