<?php
/**
 * This class loads data to global variables from the config file found in /conf/conf.ini.
 *
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 0.1
 *
 * @abstract The purpose of this class is simply to load the config file into globals for use within other classes.
 *
 * @todo Fail more gracefully.
 */

Class Parse_Config {
	/**
	 * Location of the config file (statid) set to .conf/config.ini'.
	 *
	 * @var string
	 */
	var $config_file;

	/**
	 * The constructor meerly checks to make guides the class.
	 *
	 */
	public function __construct() {
		$this->config_file = $GLOBALS['application']['app_root'] . 'conf/config.ini';
		if ($this->check_file()) {
			$this->load_configs();
		}
	}

	/**
	 * Check to see if the file exists.
	 *
	 * @return true | die
	 */
	private function check_file() {
		if (! file_exists($this->config_file)) {
			die("Could not load configuration " . $this->config_file);
		}
		else {
			return true;
		}
	}

	/**
	 * Parse over the config.ini file and load the configs into globals.
	 *
	 */
	private function load_configs() {
		$ini_array = parse_ini_file($this->config_file, 'true');
		foreach ($ini_array as $key=>$val) {
			$GLOBALS[$key] = $val;
		}
	}

}

?>