<?php
/**
 * @package MiGCMS
 * @author Justin C. Klein Keane <justin@madirish.net>
 * @version 2.0
 *
 * @abstract This object is used to collect application specific information.
 *
 * @todo
 */

require_once ('lib/util/db_object.class.php');

Class Report extends DB_Object {
	/**
	 * This is a placeholder for th persistent database object passed to the __construct.
	 *
	 * @var db_connection
	 */
	var $db;

	/**
	 * Constructor function
	 *
	 * @param db_connection $db
	 */
	public function __construct($db) {
		$this->db = $db;
		parent::__construct();
	}

	/**
	 * Get the most popular search terms
	 *
	 * @return array
	 */
	function search_term_report_1() {
		$sql = 'select count(searches_id) as cnt,
						searches_searchterm
					from searches
					group by searches_searchterm
					order by cnt DESC
					limit 10';
		$retval = $this->get_all($sql);
		return $retval;
	}

	/**
	 * Get the top 5 most popular content
	 *
	 * @return array
	 */
	function content_report_1() {
		$sql = 'select count(l.usage_log_content_id) as cnt,
					c.content_title
					from usage_log l,
						content c
					where
						l.usage_log_content_id = c.content_id
					group by l.usage_log_content_id
					order by cnt DESC
					limit 5';
		$retval = $this->get_all($sql);
		return $retval;
	}


	/**
	 * Get the top 5 least popular content
	 *
	 * @return array
	 */
	function content_report_2() {
		$sql = 'select count(l.usage_log_content_id) as cnt,
					c.content_title
					from usage_log l,
						content c
					where
						l.usage_log_content_id = c.content_id
					group by l.usage_log_content_id
					order by cnt ASC
					limit 5';
		$retval = $this->get_all($sql);
		return $retval;
	}

}
?>