#CREATE DATABASE IF NOT EXISTS migcms;

#GRANT select,insert,update,delete ON migcms.* to 'migcms'@'localhost' IDENTIFIED BY 'migcms';

#USE migcms;

CREATE TABLE IF NOT EXISTS app_log (
	app_log_id int(11) NOT NULL auto_increment,
	app_log_event_type varchar(20) default 'None',
	app_log_text text default NULL,
	app_log_datetime timestamp default current_timestamp,
	PRIMARY KEY  (app_log_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS content (
	content_id int(11) NOT NULL auto_increment,
	content_abstract text default NULL,
	content_active tinyint(4) default 0,
	content_author varchar(255) default NULL,
	content_author_email varchar(255) default NULL,
	content_content text default NULL,
	content_date date default NULL,
	content_enddate date default NULL,
	content_keywords varchar(255) default NULL,
	content_order tinyint(4) default 0,
	content_post_date timestamp default current_timestamp,
	content_sectiondefault tinyint(4) default 0,
	content_startdate date default NULL,
	content_title varchar(255) NOT NULL,
	contenttype_id int(11) NOT NULL,
	section_id int NOT NULL,
	user_id int NOT NULL,
	content_talkback tinyint(4) default 0,
	PRIMARY KEY  (content_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS contenttype (
	contenttype_id int(11) NOT NULL auto_increment,
	contenttype_active tinyint(4) default 0,
	contenttype_definition text default NULL,
	contenttype_title varchar(255) default NULL,
	PRIMARY KEY  (contenttype_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS content_image (
	content_image_id int(11) NOT NULL auto_increment,
	content_image_active tinyint(4) default 0,
	content_image_filename varchar(255) NOT NULL,
	content_image_title varchar(255) default NULL,
	PRIMARY KEY  (content_image_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS data_definitions (
	data_definitions_id int(11) NOT NULL auto_increment,
	data_definitions_title varchar(255) default NULL,
	data_definitions_active tinyint(4) default 1,
	data_definitions_sql text default NULL,
	PRIMARY KEY  (data_definitions_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS gallery (
	gallery_id int(11) NOT NULL auto_increment,
	gallery_active tinyint(4) default 0,
	gallery_description text default NULL,
	gallery_order int(11) default 0,
	gallery_title varchar(255) default NULL,
	content_id int(11) NOT NULL,
	PRIMARY KEY  (gallery_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS photo (
	photo_id int(11) NOT NULL auto_increment,
	photo_active tinyint(4) default 0,
	photo_filename varchar(255) NOT NULL,
	photo_title varchar(255) default NULL,
	photo_order int(11) default 0,
	photo_description text default NULL,
	gallery_id int(11) NOT NULL,
	PRIMARY KEY  (photo_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS related (
	content_id  int(11) NOT NULL,
	related_content_id  int(11) NOT NULL,
	related_order  int(11) NOT NULL
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS searches (
	searches_id int(11) NOT NULL auto_increment,
	searches_date timestamp default current_timestamp,
	searches_searchterm text default NULL,
	searches_results int default NULL,
	PRIMARY KEY  (searches_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS section (
	section_id int(11) NOT NULL auto_increment,
	section_active tinyint(4) default 0,
	section_title varchar(255) default NULL,
	section_order  int(11) default 0,
	section_parent_id  int(11) NOT NULL,
	section_restricted tinyint(4) default 0,
	section_static tinyint(4) default 0,
	contenttype_id tinyint(4) default 0,
	PRIMARY KEY  (section_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS usage_log (
	usage_log_id int(11) NOT NULL auto_increment,
	usage_log_id_date timestamp default current_timestamp,
	usage_log_remote_addr varchar(15) default NULL,
	usage_log_referer varchar(255) default NULL,
	usage_log_user_agent varchar(255) default NULL,
	usage_log_page varchar(255) default NULL,
	usage_log_content_id int default NULL,
	usage_log_section_id int default NULL,
	PRIMARY KEY  (usage_log_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS user (
	user_id int(11) NOT NULL auto_increment,
	user_username varchar(255) default NULL,
	user_password varchar(255) default NULL,
	user_firstname varchar(255) default NULL,
	user_lastname varchar(255) default NULL,
	user_email varchar(255) default NULL,
	PRIMARY KEY  (user_id)
	) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS talkback (
	talkback_id int(11) NOT NULL auto_increment,
	content_id int(11) NOT NULL,
	talkback_title varchar(255) default NULL,
	talkback_author varchar(255) NOT NULL,
	talkback_email varchar(100) default NULL,
	talkback_datetime timestamp default current_timestamp,
	talkback_content text default NULL,
	talkback_ip varchar(15) NOT NULL,
	PRIMARY KEY  (talkback_id)
	) TYPE=MyISAM;


INSERT into user (user_id, user_firstname, user_lastname, user_username, user_password) values (1, 'Admin', 'User', 'admin', 'admin');